////////////////////////////////////////////////////////
// Copyright (c) M.Iakobovski 11.06.2007 Version v.02 //
// Generation pseudorandom numbers sequence           //
// with direct access                                 //
////////////////////////////////////////////////////////

#define Copyright(name,x,y,z) \
static char *name = "\r\n" #x " - Copyright (C) M.Iakobovski " #y " Version " #z " ";

Copyright(lrnd32copyr,lrnd32,13.05.2006,v.01)

#include <limits.h>

typedef unsigned long UL; 
typedef unsigned short US; 

#define ULMAX ULONG_MAX
#define USMAX USHRT_MAX
#define USBITS 16

//#define BINT_BITS 500 // 500 //2200 for 1023 //500 for 255 //128 //170

#define BINT_BITS 533 // 500 //2200 for 1023 //500 for 255 //128 //170


typedef 
	struct 
	{
	int nbits;
	int nparts;

	UL *a;  //    nparts 
			//     UL  US  
	}
	BINT;

typedef BINT *LPBINT;

int bint_init_BINT_UL(LPBINT pi, int nbits, UL c);
int bint_add_BINT_UL(LPBINT pi, UL c);
int bint_sub_BINT_US(LPBINT pi, US c);
int bint_mult_BINT_UL(LPBINT pi, UL c);
int	bint_mult_BINT_ASC(LPBINT pi, char *mlt);
int bint_set_BINT_BINT(LPBINT ptarg, LPBINT psource);
int bint_add_BINT_BINT(LPBINT pi1, LPBINT pi2); // pi1*=pi2


int bint_print(FILE *f, LPBINT pi);
int bint_print_asc(FILE *f, LPBINT pi);
int bint_set_BINT_UL(LPBINT pi, UL c);
int bint_isbit(LPBINT pi, int i);

int bint_test(void);
